models/Noticia.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "noticia".
 *
 * @property int $idn
 * @property string $titulo
 * @property string $texto
 * @property string $fecha
 * @property int $ida
 *
 * @property Autor $a
 * @property Picture[] $pictures
 */
class Noticia extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'noticia';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['ida'], 'integer'],
            [['titulo'], 'string', 'max' => 63],
            [['texto'], 'string', 'max' => 255],
            [['fecha'], 'string', 'max' => 30],
            [['ida'], 'exist', 'skipOnError' => true, 'targetClass' => Autor::className(), 'targetAttribute' => ['ida' => 'ida']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idn' => 'Idn',
            'titulo' => 'Titulo',
            'texto' => 'Texto',
            'fecha' => 'Fecha',
            'ida' => 'Ida',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getA()
    {
        return $this->hasOne(Autor::className(), ['ida' => 'ida']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPictures()
    {
        return $this->hasMany(Picture::className(), ['idn' => 'idn']);
    }
    
    public function getNes()
    {
        return $this->hasMany(Etiqueta::className(), ['ide' => 'ide'])->viaTable('ne', ['idn' => 'idn']);;
    }
    
   
         /* metodo nuevo, el listado de fecha sale en castellano */ 
    public function afterFind(){
        parent::afterFind();
        // tendria el año de un registro de alquileres automaticamente de forma dinamica
        // $this->campoyear=Yii::$app->formatter->asDate($this->fecha, 'php:Y');
        //$this->fecha=Yii::$app->formatter->asDate($this->fecha, 'php:d/m/Y');
        //$this->fecha= \DateTime::createFromFormat("d/m/Y", $this->fecha)-> format("Y/m/d");
    }
    
    /* antes de grabar, el listado de fecha guarda en castellano*/
    
    /*public function beforeSave($insert){
        parent::beforeSave($insert);
      
        //$this->fecha= \DateTime::createFromFormat("d/m/Y", $this->fecha)-> format("Y/m/d");
    } */
     
    
    
}

controllers/NoticiaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Noticia;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * NoticiaController implements the CRUD actions for Noticia model.
 */
class NoticiaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

   
    /**
     * Lists all Noticia models.
     * @return mixed
     */
    
    
   public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Noticia::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    

    /**
     * Displays a single Noticia model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Noticia model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Noticia();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idn]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Noticia model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idn]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Noticia model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Noticia model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Noticia the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Noticia::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionAutoresnoticia($id){
        
        $m=Noticia::findOne($id)->a;
        return $this->render("autoresnoticia", [
            'model'=>$m
            ]);
      }
      
     /**
     * Lists all Noticia models.
     * @return mixed
     */
    public function actionList()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Noticia::find(),
        'pagination'=>[
                'pageSize'=>6,
            ]
        ]);
     return $this->render('listview', [
            'dataProvider' => $dataProvider,
        ]);
    }    
    /**
     * Lists all Noticia models.
     * @return mixed
     */
       public function actionFotosnoticia($id){
        $dataProvider = new ActiveDataProvider([
            'query' => Noticia::findOne($id)->getPictures(),
            'pagination'=>[
                'pageSize'=>6,
            ]
        ]);
        return $this->render("fotosnoticia", [
            "dataProvider"=>$dataProvider,            
            ]);
      }  
}

views/noticia/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\date\DatePicker;

/* @var $this yii\web\View */
/* @var $model app\models\Noticia */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="noticia-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'titulo')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'texto')->textInput(['maxlength' => true]) ?>
    
    <?php
    echo $form->field($model,'fecha')->widget(DatePicker::className(),[ //opcion 2 de sacar las etiquetas de los atributos
        'options' => ['placeholder' => 'Introduce la fecha de la Noticia'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'autoclose'=>true,
           //'format'=>'yyyy/mm/dd',     // opcion de guardar con fecha formato original*/ 
           'format'=>'dd/mm/yyyy', 
        ]
    ]);  
    ?>
    
    

    

    <?= $form->field($model, 'ida')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/noticia/_listar.php
<?php
use yii\helpers\Html;
use yii\helpers\ArrayHelper;

?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
        <div class="bg-gris">
        <?php
        //$etiquetas=ArrayHelper::getColumn($model->nes,"nombre");
        $etiquetas=$model->nes;
        
        foreach($etiquetas as $etiqueta){
            echo Html::a($etiqueta->nombre, ['noticia/fotosnoticia', 'id'=>$etiqueta->ide], ['class' => 'btn btn-white']);
        } 
        
        ?>
            </div>
      <div class="caption">
        <p>
          <h2><?= $model->titulo ?> </h2>
          
        </p>
        <p><?= $model->texto ?> </p>
        
        
        <p>
           <?= Html::a('Ver fotos', ['noticia/fotosnoticia', 'id'=>$model->idn], ['class' => 'btn btn-primary']);?>
           <?= Html::a('Informacion autor', ['noticia/autoresnoticia','id'=>$model->idn], ['class' => 'btn btn-primary']);?>
    </p>
                
    </div>
  </div>

views/noticia/_mostrarfotos.php
<?php
use yii\helpers\Html;

?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
      <div class="caption">
        <p>
        <?=Html::img('@web/imgs/' . $model->foto, ['class' => 'img-thumbnail']);?>
        </p>
    </div>
  </div>

views/noticia/autoresnoticia.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Autor */

$this->title = $model->ida;
$this->params['breadcrumbs'][] = ['label' => 'Autors', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="autor-view">

    <h1><?= Html::encode($this->title) ?></h1>
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'nombre',
            'alias',
            'email:email',
        ],
    ]) ?>

</div>

views/noticia/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Noticia */

$this->title = 'Create Noticia';
$this->params['breadcrumbs'][] = ['label' => 'Noticias', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="noticia-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/noticia/fotosnoticia.php
<div>
<h1>Fotos</h1>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_mostrarfotos', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/noticia/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Noticias';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="noticia-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Noticia', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'idn',
            'titulo',
            'texto',
            'fecha',
            'ida',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/noticia/indexfe.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Noticias';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="noticia-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Noticia', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'idn',
            'titulo',
            'texto',
            'fecha',
            'ida',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/noticia/listview.php
<div>
<h1>Listado de los registros</h1>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/noticia/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Noticia */

$this->title = 'Update Noticia: ' . $model->idn;
$this->params['breadcrumbs'][] = ['label' => 'Noticias', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->idn, 'url' => ['view', 'id' => $model->idn]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="noticia-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/noticia/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Noticia */

$this->title = $model->idn;
$this->params['breadcrumbs'][] = ['label' => 'Noticias', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="noticia-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->idn], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->idn], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'idn',
            'titulo',
            'texto',
            'fecha',
            'ida',
        ],
    ]) ?>

</div>